/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :cust_chat_record_info(ccc客户会话记录信息)             */
/*Create Date:2024-08-14 16:19:43                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-08-14                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-08-14                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: :COMMDB.select replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') as visitor_id ,row_number() over(partition by replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') order by id desc) rn ,* from p30_common.d_ccc_cust_info dcci  
where visitor_ids <>''*/
/*Source table 2: :COMMDB.cust_chat_ccc_record                                                     */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:cust_chat_record_info                                                               */
/*ETL Job Name:cust_chat_record_info                                                               */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE cust_chat_record_info_agi_CUR_I 
 ( LIKE :MARTDB.cust_chat_record_info)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE cust_chat_record_info_agi_INS 
( LIKE :MARTDB.cust_chat_record_info)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:cust_chat_ccc_record**********************************************************/
/*****************************************************************************************************/
INSERT INTO cust_chat_record_info_agi_CUR_I (
            chat_unique_id                          /*在线客服会话ID*/
           ,contact_channel                         /*接入渠道*/
           ,contact_app_id                          /*接入号ID*/
           ,app_name                                /*接入号名称*/
           ,queue_name                              /*队列名称*/
           ,start_time                              /*会话开始时间戳*/
           ,end_time                                /*会话结束时间戳*/
           ,chat_duration_in_seconds                /*会话持续时间*/
           ,queue_time                              /*排队时长*/
           ,referer_url                             /*来源页*/
           ,first_visit_page_url                    /*着陆页*/
           ,visitor_id                              /*访客ID*/
           ,visitor_name                            /*访客姓名*/
           ,visitor_mobile                          /*访客手机*/
           ,visitor_email                           /*访客邮箱*/
           ,visitor_company                         /*访客公司*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(p0.chat_unique_id),'')                      /*chat_unique_id*/
        ,COALESCE(TRIM(p0.contact_channel),'')                     /*contact_channel*/
        ,COALESCE(TRIM(p0.contact_app_id),'')                      /*contact_app_id*/
        ,COALESCE(TRIM(p0.app_name),'')                            /*app_name*/
        ,COALESCE(TRIM(p0.queue_name),'')                          /*queue_name*/
        ,COALESCE(p0.start_time,TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*start_time*/
        ,COALESCE(p0.end_time,TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*end_time*/
        ,COALESCE(p0.chat_duration_in_seconds,0)                   /*chat_duration_in_seconds*/
        ,COALESCE(p0.queue_time,0)                                 /*queue_time*/
        ,COALESCE(TRIM(p0.referer_url),'')                         /*referer_url*/
        ,COALESCE(TRIM(p0.first_visit_page_url),'')                /*first_visit_page_url*/
        ,COALESCE(TRIM(p0.visitor_id),'')                          /*visitor_id*/
        ,coalesce(p1.name,'')                                      /*visitor_name*/
        ,coalesce(p1.tel,'')                                       /*visitor_mobile*/
        ,coalesce(p1.email,'')                                     /*visitor_email*/
        ,coalesce(p1.company,'')                                   /*visitor_company*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('cust_chat_ccc_record',1,3)                        /*Src_Sysname*/
        ,'cust_chat_ccc_record'                                    /*Src_Table*/
        
FROM :COMMDB.cust_chat_ccc_record  p0
LEFT JOIN (select replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') as visitor_id ,row_number() over(partition by replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') order by id desc) rn ,* from p30_common.d_ccc_cust_info dcci  
where visitor_ids <>'') p1
        ON p0 .visitor_id =p1 .visitor_id 
and p1.rn=1
;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO cust_chat_record_info_agi_INS (
         contact_channel                                           /*接入渠道*/
        ,contact_app_id                                            /*接入号ID*/
        ,app_name                                                  /*接入号名称*/
        ,queue_name                                                /*队列名称*/
        ,start_time                                                /*会话开始时间戳*/
        ,end_time                                                  /*会话结束时间戳*/
        ,chat_duration_in_seconds                                  /*会话持续时间*/
        ,queue_time                                                /*排队时长*/
        ,referer_url                                               /*来源页*/
        ,first_visit_page_url                                      /*着陆页*/
        ,visitor_id                                                /*访客ID*/
        ,visitor_name                                              /*访客姓名*/
        ,visitor_mobile                                            /*访客手机*/
        ,visitor_email                                             /*访客邮箱*/
        ,visitor_company                                           /*访客公司*/
        ,chat_unique_id                                            /*在线客服会话ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.contact_channel                                           /*接入渠道*/
        ,P1.contact_app_id                                            /*接入号ID*/
        ,P1.app_name                                                  /*接入号名称*/
        ,P1.queue_name                                                /*队列名称*/
        ,P1.start_time                                                /*会话开始时间戳*/
        ,P1.end_time                                                  /*会话结束时间戳*/
        ,P1.chat_duration_in_seconds                                  /*会话持续时间*/
        ,P1.queue_time                                                /*排队时长*/
        ,P1.referer_url                                               /*来源页*/
        ,P1.first_visit_page_url                                      /*着陆页*/
        ,P1.visitor_id                                                /*访客ID*/
        ,P1.visitor_name                                              /*访客姓名*/
        ,P1.visitor_mobile                                            /*访客手机*/
        ,P1.visitor_email                                             /*访客邮箱*/
        ,P1.visitor_company                                           /*访客公司*/
        ,P1.chat_unique_id                                            /*在线客服会话ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM cust_chat_record_info_agi_CUR_I P1
LEFT JOIN :MARTDB.cust_chat_record_info P2
ON    P1.contact_channel = P2.contact_channel
    AND P1.contact_app_id = P2.contact_app_id
    AND P1.app_name = P2.app_name
    AND P1.queue_name = P2.queue_name
    AND P1.start_time = P2.start_time
    AND P1.end_time = P2.end_time
    AND P1.chat_duration_in_seconds = P2.chat_duration_in_seconds
    AND P1.queue_time = P2.queue_time
    AND P1.referer_url = P2.referer_url
    AND P1.first_visit_page_url = P2.first_visit_page_url
    AND P1.visitor_id = P2.visitor_id
    AND P1.visitor_name = P2.visitor_name
    AND P1.visitor_mobile = P2.visitor_mobile
    AND P1.visitor_email = P2.visitor_email
    AND P1.visitor_company = P2.visitor_company
    AND P1.chat_unique_id = P2.chat_unique_id
    
WHERE  P2.contact_channel IS NULL
    OR P2.contact_app_id IS NULL
    OR P2.app_name IS NULL
    OR P2.queue_name IS NULL
    OR P2.start_time IS NULL
    OR P2.end_time IS NULL
    OR P2.chat_duration_in_seconds IS NULL
    OR P2.queue_time IS NULL
    OR P2.referer_url IS NULL
    OR P2.first_visit_page_url IS NULL
    OR P2.visitor_id IS NULL
    OR P2.visitor_name IS NULL
    OR P2.visitor_mobile IS NULL
    OR P2.visitor_email IS NULL
    OR P2.visitor_company IS NULL
    OR P2.chat_unique_id IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :MARTDB.cust_chat_record_info (
         contact_channel                                           /*接入渠道*/
        ,contact_app_id                                            /*接入号ID*/
        ,app_name                                                  /*接入号名称*/
        ,queue_name                                                /*队列名称*/
        ,start_time                                                /*会话开始时间戳*/
        ,end_time                                                  /*会话结束时间戳*/
        ,chat_duration_in_seconds                                  /*会话持续时间*/
        ,queue_time                                                /*排队时长*/
        ,referer_url                                               /*来源页*/
        ,first_visit_page_url                                      /*着陆页*/
        ,visitor_id                                                /*访客ID*/
        ,visitor_name                                              /*访客姓名*/
        ,visitor_mobile                                            /*访客手机*/
        ,visitor_email                                             /*访客邮箱*/
        ,visitor_company                                           /*访客公司*/
        ,chat_unique_id                                            /*在线客服会话ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.contact_channel                                           /*接入渠道*/
        ,P1.contact_app_id                                            /*接入号ID*/
        ,P1.app_name                                                  /*接入号名称*/
        ,P1.queue_name                                                /*队列名称*/
        ,P1.start_time                                                /*会话开始时间戳*/
        ,P1.end_time                                                  /*会话结束时间戳*/
        ,P1.chat_duration_in_seconds                                  /*会话持续时间*/
        ,P1.queue_time                                                /*排队时长*/
        ,P1.referer_url                                               /*来源页*/
        ,P1.first_visit_page_url                                      /*着陆页*/
        ,P1.visitor_id                                                /*访客ID*/
        ,P1.visitor_name                                              /*访客姓名*/
        ,P1.visitor_mobile                                            /*访客手机*/
        ,P1.visitor_email                                             /*访客邮箱*/
        ,P1.visitor_company                                           /*访客公司*/
        ,P1.chat_unique_id                                            /*在线客服会话ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM cust_chat_record_info_agi_INS P1
ON CONFLICT ( chat_unique_id)
DO UPDATE SET
     chat_unique_id=excluded.chat_unique_id
    ,contact_channel=excluded.contact_channel
    ,contact_app_id=excluded.contact_app_id
    ,app_name=excluded.app_name
    ,queue_name=excluded.queue_name
    ,start_time=excluded.start_time
    ,end_time=excluded.end_time
    ,chat_duration_in_seconds=excluded.chat_duration_in_seconds
    ,queue_time=excluded.queue_time
    ,referer_url=excluded.referer_url
    ,first_visit_page_url=excluded.first_visit_page_url
    ,visitor_id=excluded.visitor_id
    ,visitor_name=excluded.visitor_name
    ,visitor_mobile=excluded.visitor_mobile
    ,visitor_email=excluded.visitor_email
    ,visitor_company=excluded.visitor_company
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

